#!/bin/bash

# Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
# 
# This software is published by the license of CPU-OS License, you can use and 
# distibuted this software under this License. See CPU-OS Liense for more detail.
#
# You should have receive a copy of CPU-OS License. If not, please contact us 
# by email <support_os@cpu-os.ac.cn> 

###################################
#Modify the /etc/fstab for fastboot
#Modi@2018.01.19 By Luhp
#优化/etc/fstab文件前会备份为/etc/fstab.orig，加参数reset后可以从/etc/fstab.orig还原/etc/fstab
###################################
if [ ! -f /etc/fstab ]; then
   echo "No /etc/fstab file"
   exit
fi
if [ "X$1" = "Xreset" ]; then
   if [ -f /etc/fstab.orig ]; then
      /bin/cp -f /etc/fstab.orig /etc/fstab
   fi
   exit
fi
zxdnvme=`cat /etc/fstab | grep /dev/nvme0n1 | head -n1`
if [ "X$zxdnvme" = "X" ]; then
   echo $zxdnvme 
   echo "Not ZXD nvme block device Or has been modified."
   exit
fi
zxdnvmeroot=`cat /etc/fstab | grep /dev/nvme0n1 | grep '/ was on' | awk '{print $5}'`
zxdnvmeswap=`cat /etc/fstab | grep /dev/nvme0n1 | grep 'swap was on' | awk '{print $5}'`
zxdnvmeefi=`cat /etc/fstab | grep /dev/nvme0n1 | grep 'efi was on' | awk '{print $5}'`
echo $zxdnvmeroot $zxdnvmeswap

if [ "X$zxdnvmeroot" = "X" ]; then
   echo "Not root string Or has been modified."
   exit
fi
zxdnvmerootuuid=`cat /etc/fstab | grep ^UUID | grep 'errors=remount-ro' | awk '{print $1}'`
zxdnvmeswapuuid=`cat /etc/fstab | grep ^UUID | grep 'swap' | awk '{print $1}'`
zxdnvmeefiuuid=`cat /etc/fstab | grep ^UUID | grep '/efi' | awk '{print $1}'`
zxdnvmerootops=`cat /etc/fstab | grep ^UUID | grep 'errors=remount-ro' | awk '{print $4}'`
echo $zxdnvmerootuuid $zxdnvmeswapuuid
if [ "X$zxdnvmerootuuid" = "X" ]; then
   echo "Not root UUID string or has been modified."
   exit
fi

if [ ! -f /etc/fstab.orig ]; then
   /bin/cp /etc/fstab /etc/fstab.orig
fi
#echo "cat /etc/fstab | sed 's#${zxdnvmerootuuid}#${zxdnvmeroot}#'"

if [ "X$zxdnvmerootops" = "X" ]; then
   cat /etc/fstab.orig | sed -e 's#'${zxdnvmerootuuid}'#'${zxdnvmeroot}'#' -e 's#'${zxdnvmeswapuuid}'#'${zxdnvmeswap}'#' -e 's#'${zxdnvmeefiuuid}'#'${zxdnvmeefi}'#' > /etc/fstab
else
   cat /etc/fstab.orig | sed -e 's#'${zxdnvmerootuuid}'#'${zxdnvmeroot}'#' -e 's#'${zxdnvmeswapuuid}'#'${zxdnvmeswap}'#' -e 's#'${zxdnvmeefiuuid}'#'${zxdnvmeefi}'#' -e 's#'${zxdnvmerootops}'#noatime,errors=remount-ro#' > /etc/fstab
fi
